SystemOrganization addCategory: #'XMLRPC-Server-Tests'!

Object subclass: #XMLRPCStandardEcho
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XMLRPC-Server-Tests'!

!XMLRPCStandardEcho class methodsFor: 'as yet unclassified' stamp: 'Skrish 9/19/2010 10:31'!
addTests
	"XMLRPCStandardEcho addTests"

	XMLRPCServerRequest registerService: 'echo.echoArray' class: self selector: #echo:.
	XMLRPCServerRequest registerService: 'echo.echoBinary' class: self selector: #echo:.
	XMLRPCServerRequest registerService: 'echo.echoBoolean' class: self selector: #echo:.
	XMLRPCServerRequest registerService: 'echo.echoDateTime' class: self  selector: #echo:.
	XMLRPCServerRequest registerService: 'echo.echoDouble' class: self selector: #echo:.
	XMLRPCServerRequest registerService: 'echo.echoInt' class: self selector: #echo:.
	XMLRPCServerRequest registerService: 'echo.echoString' class: self selector: #echo:.
	XMLRPCServerRequest registerService: 'echo.echoStruct' class: self selector: #echo:! !

!XMLRPCStandardEcho class methodsFor: 'as yet unclassified' stamp: 'Skrish 9/19/2010 10:54'!
echo: aValue

   ^aValue first! !

Object subclass: #XMLRPCStandardValidator
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XMLRPC-Server-Tests'!

!XMLRPCStandardValidator class methodsFor: 'as yet unclassified' stamp: 'SantiagoBragagnolo 9/20/2012 11:56'!
addTests
	"XMLRPCStandardValidator addTests"

	XMLRPCService atPort: 8081 serve: 
	{
		'validator1.arrayOfStructsTest' -> { self-> #arrayOfStructsTest:}.
		'validator1.countTheEntities'  ->  { self ->  #countTheEntities:}.
		'validator1.echoStructTest'  ->  { self ->  #echoStructTest:}.
		'validator1.easyStructTest'  ->  { self  ->  #easyStructTest:}.
		'validator1.moderateSizeArrayCheck'  ->  { self ->  #moderateSizeArrayCheck:}.
		'validator1.nestedStructTest'  ->  { self ->  #nestedStructTest:}.
		'validator1.simpleStructReturnTest'  ->  { self ->  #simpleStructReturnTest:}.
		'validator1.manyTypesTest'  ->  { self ->  #manyTypesTest: }.	
	} asXMLRPCHttpModule at:'/'.
	
! !

!XMLRPCStandardValidator class methodsFor: 'as yet unclassified' stamp: ''!
arrayOfStructsTest: aCollection 
	| ret |
	ret := 0.
	aCollection first	do: [:each | ret := ret
								+ (each at: 'curly')].
	^ ret! !

!XMLRPCStandardValidator class methodsFor: 'as yet unclassified' stamp: 'M.F. 9/6/2002 16:42'!
countTheEntities: aCollection 
	| ret string |
	ret := Dictionary new.
	string := aCollection first.
	ret
		at: 'ctLeftAngleBrackets'
		put: (string occurrencesOf: $<).
	ret
		at: 'ctRightAngleBrackets'
		put: (string occurrencesOf: $>).
	ret
		at: 'ctAmpersands'
		put: (string occurrencesOf: $&).
	ret
		at: 'ctApostrophes'
		put: (string occurrencesOf: $').
	ret
		at: 'ctQuotes'
		put: (string occurrencesOf: $").
	^ ret! !

!XMLRPCStandardValidator class methodsFor: 'as yet unclassified' stamp: ''!
easyStructTest: aCollection
	| ret |
	ret := 0. aCollection first valuesDo: [ :each | ret := ret + each ].
	^ret! !

!XMLRPCStandardValidator class methodsFor: 'as yet unclassified' stamp: 'GermanArduino 3/26/2011 13:11'!
echoStructTest: aDictionary 

	^ aDictionary! !

!XMLRPCStandardValidator class methodsFor: 'as yet unclassified' stamp: 'Skrish 9/19/2010 10:49'!
manyTypesTest: aCollection
    "simply return the decoded values in aCollection encoded"
	| arr x | 
	x := 1.
	arr := Array new: 6.
	aCollection do: [ :each | arr at: x put: each. x := x+1].
	^arr ! !

!XMLRPCStandardValidator class methodsFor: 'as yet unclassified' stamp: ''!
moderateSizeArrayCheck: aCollection 
	| arr |
	arr := aCollection first.
	^ (arr first), (arr last)! !

!XMLRPCStandardValidator class methodsFor: 'as yet unclassified' stamp: ''!
nestedStructTest: aCollection
	| struct ret |
	struct := aCollection first.
	ret := 0.
	(((struct at: '2000') at: '04') at: '01') valuesDo: [ :each | ret := ret + each].
	^ ret! !

!XMLRPCStandardValidator class methodsFor: 'as yet unclassified' stamp: ''!
simpleStructReturnTest: aCollection 
	| num dict |
	dict := Dictionary new.
	num := aCollection first.
	dict at: 'times10' put: num * 10;
		 at: 'times100' put: num * 100;
		 at: 'times1000' put: num * 1000.
	^ dict! !

TestCase subclass: #XMLRPCKomServerEchoTest
	instanceVariableNames: 'newServer'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XMLRPC-Server-Tests'!

!XMLRPCKomServerEchoTest methodsFor: 'as yet unclassified' stamp: 'SantiagoBragagnolo 1/25/2013 11:07'!
setUp
"self new setUp"
"XMLRPCHttpModule stop"
	XMLRPCServer defaultClass: XMLRPCKomServer.
	newServer := false.
	XMLRPCStandardEcho addTests.
	(HttpService servicesNamed: 'test123') 
		ifEmpty: [XMLRPCHttpModule start; setDebugMode.
			(Delay forMilliseconds: 5) wait.
			newServer := true]! !

!XMLRPCKomServerEchoTest methodsFor: 'as yet unclassified' stamp: 'SantiagoBragagnolo 1/25/2013 11:07'!
tearDown
	 XMLRPCHttpModule stop.
	XMLRPCServer initialize.! !

!XMLRPCKomServerEchoTest methodsFor: 'as yet unclassified' stamp: 'Skrish 9/19/2010 11:32'!
testThroughClient
" bring in tests here independently in next version.. for now just reuse the XMLRPCTests"

 | client |

client := XMLRPCTest suite.
client run.

	
! !

TestCase subclass: #XMLRPCKomServerTest
	instanceVariableNames: 'newServer'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XMLRPC-Server-Tests'!

!XMLRPCKomServerTest methodsFor: 'as yet unclassified' stamp: 'SantiagoBragagnolo 1/25/2013 11:07'!
setUp
	XMLRPCServer defaultClass: XMLRPCKomServer.
	XMLRPCStandardValidator addTests.
	(Delay forMilliseconds: 5) wait.! !

!XMLRPCKomServerTest methodsFor: 'as yet unclassified' stamp: 'SantiagoBragagnolo 1/25/2013 11:07'!
tearDown
	XMLRPCService destroy.
	XMLRPCServer initialize.! !

!XMLRPCKomServerTest methodsFor: 'as yet unclassified' stamp: 'SantiagoBragagnolo 9/20/2012 12:50'!
testDictionary
	| d p r |
	d := Dictionary new.
	d at: 'true' put: true.
	d at: 'Markus' put: 'Fritsche'.
	p := XMLRPCProxy new url: 'http://localhost:8081/' asUrl.
	r := p invokeMethod: 'validator1.echoStructTest' withStruct: d.
	self assert: r = d! !

!XMLRPCKomServerTest methodsFor: 'as yet unclassified' stamp: 'SantiagoBragagnolo 9/19/2012 15:48'!
testHallo
	| p |
	p := XMLRPCProxy new url: 'http://localhost:8081/' asUrl.
	p invokeMethod: 'validator1.echoStructTest' withArgs: #('Hallo')
! !

TestCase subclass: #XMLRPCZNServerEchoTest
	instanceVariableNames: 'newServer'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XMLRPC-Server-Tests'!

!XMLRPCZNServerEchoTest methodsFor: 'as yet unclassified' stamp: 'SantiagoBragagnolo 1/25/2013 11:19'!
setUp
"self new setUp"
"XMLRPCHttpModule stop"
	XMLRPCServer defaultClass: XMLRPCZNServer.
	newServer := false.
	XMLRPCStandardEcho addTests.
	(HttpService servicesNamed: 'test123') 
		ifEmpty: [XMLRPCHttpModule start; setDebugMode.
			(Delay forMilliseconds: 5) wait.
			newServer := true]! !

!XMLRPCZNServerEchoTest methodsFor: 'as yet unclassified' stamp: 'SantiagoBragagnolo 1/25/2013 11:19'!
tearDown
	 XMLRPCHttpModule stop.
	XMLRPCServer initialize.! !

!XMLRPCZNServerEchoTest methodsFor: 'as yet unclassified' stamp: 'SantiagoBragagnolo 1/25/2013 11:19'!
testThroughClient
" bring in tests here independently in next version.. for now just reuse the XMLRPCTests"

 | client |

client := XMLRPCTest suite.
client run.

	
! !

TestCase subclass: #XMLRPCZNServerTest
	instanceVariableNames: 'newServer'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XMLRPC-Server-Tests'!

!XMLRPCZNServerTest methodsFor: 'as yet unclassified' stamp: 'SantiagoBragagnolo 1/25/2013 11:19'!
setUp
	XMLRPCServer defaultClass: XMLRPCZNServer.
	XMLRPCStandardValidator addTests.
	(Delay forMilliseconds: 5) wait.! !

!XMLRPCZNServerTest methodsFor: 'as yet unclassified' stamp: 'SantiagoBragagnolo 1/25/2013 11:19'!
tearDown
	XMLRPCService destroy.
	XMLRPCServer initialize.! !

!XMLRPCZNServerTest methodsFor: 'as yet unclassified' stamp: 'SantiagoBragagnolo 1/25/2013 11:19'!
testDictionary
	| d p r |
	d := Dictionary new.
	d at: 'true' put: true.
	d at: 'Markus' put: 'Fritsche'.
	p := XMLRPCProxy new url: 'http://localhost:8081/' asUrl.
	r := p invokeMethod: 'validator1.echoStructTest' withStruct: d.
	self assert: r = d! !

!XMLRPCZNServerTest methodsFor: 'as yet unclassified' stamp: 'SantiagoBragagnolo 1/25/2013 11:19'!
testHallo
	| p |
	p := XMLRPCProxy new url: 'http://localhost:8081/' asUrl.
	p invokeMethod: 'validator1.echoStructTest' withArgs: #('Hallo')
! !
